diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
index 8155d2e83..6e0d8f18e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -669,4 +777,131 @@ public class FontRendererDefault extends FontRenderer {
         }
         return value;
     }
+
+    protected static class TessellatorDecorations extends TessellatorBase implements TessellatorColor {
+        private static final int VERT_SIZE = Float.BYTES * 3 + 4;
+        private boolean lockColor = false;
+
+        private int color;
+
+        private final int vao;
+        private final int vbo;
+
+        private int quadVertCount = 0;
+
+        public TessellatorDecorations(@NotNull String name, int initialCapacity) {
+            super(name, initialCapacity);
+            this.vao = GL41.glGenVertexArrays();
+            this.vbo = GL41.glGenBuffers();
+
+            GL41.glBindVertexArray(this.vao);
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
+
+            GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, VERT_SIZE, 0);
+            GL41.glVertexAttribPointer(1, 4, GL41.GL_UNSIGNED_BYTE, true, VERT_SIZE, Float.BYTES * 3);
+            GL41.glVertexAttrib2f(2, 0f, 0f);
+            GL41.glVertexAttrib2f(3, 15.5f/16f, 15.5f/16f);
+            GL41.glVertexAttrib3f(4, 0, -1f, 0);
+
+            GL41.glEnableVertexAttribArray(0);
+            GL41.glEnableVertexAttribArray(1);
+            GL41.glBindVertexArray(0);
+        }
+
+        @Override
+        public void startDrawing(@NotNull DrawMode drawMode) {
+            super.startDrawing(drawMode);
+
+            this.lockColor = false;
+            this.quadVertCount = 0;
+            if (Tessellator.QUAD_EMULATION && drawMode == DrawMode.QUADS) {
+                this.drawMode = DrawMode.TRIANGLES;
+            }
+            setColor1i(0xFFFFFFFF);
+        }
+
+        @Override
+        public void addVertex(double x, double y, double z) {
+            checkIsDrawing();
+            checkCanFit(64);
+
+            this.data.putFloat((float) (this.offsetX + x));
+            this.data.putFloat((float) (this.offsetY + y));
+            this.data.putFloat((float) (this.offsetZ + z));
+
+            this.data.putInt(this.color);
+            this.vertexCount++;
+
+            if (Tessellator.QUAD_EMULATION && this.quadVertCount % 4 == 2) {
+                checkCanFit(128);
+                this.data.put(this.data.position(), this.data, this.data.position() - VERT_SIZE * 3, VERT_SIZE);
+                this.data.put(this.data.position() + VERT_SIZE, this.data, this.data.position() - VERT_SIZE, VERT_SIZE);
+                this.data.position(this.data.position() + VERT_SIZE * 2);
+                this.vertexCount += 2;
+            }
+
+            this.quadVertCount++;
+        }
+
+        @Override
+        public void draw() {
+            if(!this.drawing) {
+                throw new IllegalStateException(this.name + " already drawing!");
+            }
+
+            this.drawing = false;
+
+            if (this.vertexCount == 0) return;
+
+            GL41.glBindVertexArray(this.vao);
+            GL41.glVertexAttrib2f(3, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
+            GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STREAM_DRAW);
+
+            GL41.glDrawArrays(this.drawMode.cap, 0, this.vertexCount);
+            GL41.glBindVertexArray(0);
+        }
+
+        @Override
+        public @NotNull RenderBuffer record(int vao, int vbo) {
+            if(!this.drawing) {
+                throw new IllegalStateException(this.name + " already drawing!");
+            }
+
+            this.drawing = false;
+
+            GL41.glBindVertexArray(this.vao);
+            GL41.glVertexAttrib2f(3, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+
+            GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
+            GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STATIC_DRAW);
+
+            GL41.glDrawArrays(this.drawMode.cap, 0, this.vertexCount);
+            GL41.glBindVertexArray(0);
+
+            return new RenderBuffer(vao, vbo, 0, this.vertexCount, this.drawMode);
+        }
+
+        @Override
+        public void setColor1i(int argb) {
+            checkIsDrawing();
+            if (this.lockColor) {
+                return;
+            }
+
+            int a = (argb >> 24) & 0xFF;
+            int r = (argb >> 16) & 0xFF;
+            int g = (argb >> 8) & 0xFF;
+            int b = argb & 0xFF;
+
+            this.color = a << 24 | b << 16 | g << 8 | r;
+        }
+
+        @Override
+        public void lockColor() {
+            checkIsDrawing();
+            this.lockColor = true;
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleBase.java b/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleBase.java
index 24e79b7a0..0f12e6d85 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleBase.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleBase.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.Color;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -8,7 +7,6 @@ import org.jetbrains.annotations.Nullable;
 @SuppressWarnings("unused")
 public abstract class RenderDoubleBase {
     protected @NotNull FontRenderer fontRenderer;
-    protected @NotNull Tessellator tessellator;
     protected @NotNull CharSequence chars;
     protected @NotNull Font font;
     protected double x;
@@ -24,11 +22,13 @@ public abstract class RenderDoubleBase {
 
     }
 
-    public @NotNull RenderDoubleBase init(@NotNull final FontRenderer fontRenderer, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        if (this.needCall) throw new IllegalStateException("Init called before prior draw call!");
+    public @NotNull RenderDoubleBase init(@NotNull final FontRenderer fontRenderer, @NotNull final CharSequence chars, final double x, final double y, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        if (this.needCall) {
+            this.needCall = false;
+            throw new IllegalStateException("Init called before prior draw call!");
+        }
         this.fontRenderer = fontRenderer;
         this.font = this.fontRenderer.getFont();
-        this.tessellator = tessellator;
         this.chars = chars;
         this.x = x;
         this.y = y;
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleConstrainedBase.java b/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleConstrainedBase.java
index 078d8ab3d..f23aef77b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleConstrainedBase.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/RenderDoubleConstrainedBase.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.Color;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -8,7 +7,6 @@ import org.jetbrains.annotations.Nullable;
 @SuppressWarnings("unused")
 public abstract class RenderDoubleConstrainedBase {
     protected @NotNull FontRenderer fontRenderer;
-    protected @NotNull Tessellator tessellator;
     protected @NotNull CharSequence chars;
     protected @NotNull Font font;
     protected double x;
@@ -27,11 +25,13 @@ public abstract class RenderDoubleConstrainedBase {
 
     }
 
-    public @NotNull RenderDoubleConstrainedBase init(@NotNull final FontRenderer fontRenderer, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final double x, final double y, final double maxWidth, final double maxHeight, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        if (this.needCall) throw new IllegalStateException("Init called before prior draw call!");
+    public @NotNull RenderDoubleConstrainedBase init(@NotNull final FontRenderer fontRenderer, @NotNull final CharSequence chars, final double x, final double y, final double maxWidth, final double maxHeight, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        if (this.needCall) {
+            this.needCall = false;
+            throw new IllegalStateException("Init called before prior draw call!");
+        }
         this.fontRenderer = fontRenderer;
         this.font = this.fontRenderer.getFont();
-        this.tessellator = tessellator;
         this.chars = chars;
         this.x = x;
         this.y = y;
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerBase.java b/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerBase.java
index 3282f48cd..d4f7d7e0d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerBase.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerBase.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.Color;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -8,7 +7,6 @@ import org.jetbrains.annotations.Nullable;
 @SuppressWarnings("unused")
 public abstract class RenderIntegerBase {
     protected @NotNull FontRenderer fontRenderer;
-    protected @NotNull Tessellator tessellator;
     protected @NotNull CharSequence chars;
     protected @NotNull Font font;
     protected int x;
@@ -24,11 +22,13 @@ public abstract class RenderIntegerBase {
 
     }
 
-    public @NotNull RenderIntegerBase init(@NotNull final FontRenderer fontRenderer, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        if (this.needCall) throw new IllegalStateException("Init called before prior draw call!");
+    public @NotNull RenderIntegerBase init(@NotNull final FontRenderer fontRenderer, @NotNull final CharSequence chars, final int x, final int y, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        if (this.needCall) {
+            this.needCall = false;
+            throw new IllegalStateException("Init called before prior draw call!");
+        }
         this.fontRenderer = fontRenderer;
         this.font = this.fontRenderer.getFont();
-        this.tessellator = tessellator;
         this.chars = chars;
         this.x = x;
         this.y = y;
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerConstrainedBase.java b/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerConstrainedBase.java
index daddc98e3..74badec98 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerConstrainedBase.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/RenderIntegerConstrainedBase.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.font;
 
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.Color;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -8,7 +7,6 @@ import org.jetbrains.annotations.Nullable;
 @SuppressWarnings("unused")
 public abstract class RenderIntegerConstrainedBase {
     protected @NotNull FontRenderer fontRenderer;
-    protected @NotNull Tessellator tessellator;
     protected @NotNull CharSequence chars;
     protected @NotNull Font font;
     protected int x;
@@ -27,11 +25,13 @@ public abstract class RenderIntegerConstrainedBase {
 
     }
 
-    public @NotNull RenderIntegerConstrainedBase init(@NotNull final FontRenderer fontRenderer, @NotNull final Tessellator tessellator, @NotNull final CharSequence chars, final int x, final int y, final int maxWidth, final int maxHeight, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
-        if (this.needCall) throw new IllegalStateException("Init called before prior draw call!");
+    public @NotNull RenderIntegerConstrainedBase init(@NotNull final FontRenderer fontRenderer, @NotNull final CharSequence chars, final int x, final int y, final int maxWidth, final int maxHeight, final double @Nullable [] xPosBuffer, final double @Nullable [] yPosBuffer, final long @Nullable [] configBuffer) {
+        if (this.needCall) {
+            this.needCall = false;
+            throw new IllegalStateException("Init called before prior draw call!");
+        }
         this.fontRenderer = fontRenderer;
         this.font = this.fontRenderer.getFont();
-        this.tessellator = tessellator;
         this.chars = chars;
         this.x = x;
         this.y = y;
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
index 9e833c112..650aa367e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
@@ -1,11 +1,16 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.ItemRenderer;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.FrontFace;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
@@ -13,8 +18,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
+import org.joml.Math;
 import org.useless.dragonfly.DisplayPos;
 
 public abstract class ItemModel {
@@ -23,40 +27,41 @@ public abstract class ItemModel {
         this.item = item;
     }
 
-    public abstract void render(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, float brightness, float alpha, float partialTick, boolean mirrorX); // TODO figure out if theres a way to not explicitly need to mirrorX in the model itself
-    public abstract void renderItemOverlayIntoGUI(@NotNull Tessellator tessellator, @NotNull FontRenderer fontRenderer, @NotNull TextureManager textureManager, @NotNull ItemStack itemstack, int x, int y, @Nullable String override, float alpha);
+    public abstract void render(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, int lightmapCoord, float partialTick, boolean mirrorX); // TODO figure out if theres a way to not explicitly need to mirrorX in the model itself
+    public abstract void renderItemOverlayIntoGUI(@NotNull TessellatorGeneral tessellator, @NotNull FontRenderer fontRenderer, @NotNull TextureManager textureManager, @NotNull ItemStack itemstack, int x, int y, @Nullable String override, float alpha);
 
-    public void renderGui(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, float brightness, float alpha, float partialTick) {
-        GL11.glPushMatrix();
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glEnable(GL11.GL_CULL_FACE);
-        GL11.glTranslatef(x + 8, y + 8, 0);
-        GL11.glScalef(16, -16, 1);
-        render(tessellator, holder, itemStack, DisplayPos.GUI, false, 1, brightness, alpha, partialTick, false);
-        GL11.glEnable(GL11.GL_LIGHTING);
-        GL11.glDisable(GL11.GL_CULL_FACE);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glPopMatrix();
+    public void renderGui(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, int lightmapCoord, float partialTick) {
+        GLRenderer.pushFrame();
+        GLRenderer.globalSetLightEnabled(false);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.CULL_FACE);
+        GLRenderer.modelM4f().translate(x + 8, y + 8, 0);
+        GLRenderer.modelM4f().scale(16, -16, 1);
+        render(tessellator, holder, itemStack, DisplayPos.GUI, false, 1, LightmapHelper.getLightmapCoord(15, 15), partialTick, false);
+        GLRenderer.globalSetLightEnabled(true);
+        GLRenderer.popFrame();
     }
 
-    public void renderItemEntity(@NotNull Tessellator tessellator, @NotNull ItemStack itemStack, boolean items3d, int clusterSize, int ticks, float yaw, float brightness, float alpha, float partialTick) {
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glEnable(GL11.GL_BLEND);
+    public void renderItemEntity(@NotNull TessellatorGeneral tessellator, @NotNull ItemStack itemStack, boolean items3d, int clusterSize, int ticks, float yaw, int lightmap, float partialTick) {
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.enableState(State.BLEND);
         if (items3d) {
-            GL11.glRotated(yaw, 0, 1, 0);
+            GLRenderer.modelM4f().rotateY(Math.toRadians(yaw));
         } else {
-            GL11.glRotatef(180F - EntityRenderDispatcher.instance.viewLerpYaw, 0.0F, 1.0F, 0.0F);
+            GLRenderer.modelM4f().rotateY(Math.toRadians(180F - EntityRendererDispatcher.instance.viewLerpYaw));
         }
-        render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, brightness, alpha, partialTick, false);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, lightmap, partialTick, false);
+        GLRenderer.disableState(State.BLEND);
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
-    public void renderFirstPerson(@NotNull Tessellator tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, float brightness, float alpha, float partialTick) {
-        GL11.glPushMatrix();
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+    public void renderFirstPerson(@NotNull TessellatorGeneral tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, int lightmapCoord, float partialTick) {
+        GLRenderer.pushFrame();
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.CULL_FACE);
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         final float swingProgress = player.getSwingProgress(partialTick);
         final float animationProgress2 = MathHelper.sin(swingProgress * MathHelper.PI);
         final float animationProgress = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
@@ -66,39 +71,39 @@ public abstract class ItemModel {
             final float yOff = -8.25f/16f -(1.0F - itemRenderer.getEquippedProgress(partialTick)) * 0.6F;
             final float zOff = -0.725f;
 
-            GL11.glScalef(-1, 1, 1);
-            GL11.glTranslatef(-animationProgress * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -animationProgress2 * 0.2F); // Makes swing travel in an arc
-            GL11.glTranslatef(xOff, yOff, zOff);
+            GLRenderer.modelM4f().scale(-1, 1, 1);
+            GLRenderer.modelM4f().translate(-animationProgress * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -animationProgress2 * 0.2F); // Makes swing travel in an arc
+            GLRenderer.modelM4f().translate(xOff, yOff, zOff);
 
             float animationProgress3 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
-            GL11.glRotatef(45, 0, 1, 0);
-            GL11.glRotatef(-animationProgress3 * 20F, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(-animationProgress * 20F, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(-animationProgress * 80F, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(-45, 0, 1, 0);
+            GLRenderer.modelM4f().rotateY(Math.toRadians(45));
+            GLRenderer.modelM4f().rotateY(Math.toRadians(-animationProgress3) * 20F);
+            GLRenderer.modelM4f().rotateZ(Math.toRadians(-animationProgress) * 20F);
+            GLRenderer.modelM4f().rotateX(Math.toRadians(-animationProgress) * 80F);
+            GLRenderer.modelM4f().rotateY(Math.toRadians(-45));
 
-            GL11.glFrontFace(GL11.GL_CW);
-            render(tessellator,player, itemStack, DisplayPos.FIRST_PERSON_LEFT_HAND, true, 1, brightness, alpha, partialTick, true);
-            GL11.glFrontFace(GL11.GL_CCW);
+            GLRenderer.setFrontFace(FrontFace.CW);
+            render(tessellator,player, itemStack, DisplayPos.FIRST_PERSON_LEFT_HAND, true, 1, lightmapCoord, partialTick, true);
+            GLRenderer.setFrontFace(FrontFace.CCW);
         } else {
             final float xOff = 9/16f;
             final float yOff = -8.25f/16f -(1.0F - itemRenderer.getEquippedProgress(partialTick)) * 0.6F;
             final float zOff = -0.725f;
 
-            GL11.glTranslatef(-animationProgress * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -animationProgress2 * 0.2F); // Makes swing travel in an arc
-            GL11.glTranslatef(xOff, yOff, zOff);
+            GLRenderer.modelM4f().translate(-animationProgress * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -animationProgress2 * 0.2F); // Makes swing travel in an arc
+            GLRenderer.modelM4f().translate(xOff, yOff, zOff);
 
             float animationProgress3 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
-            GL11.glRotatef(45, 0, 1, 0);
-            GL11.glRotatef(-animationProgress3 * 20F, 0.0F, 1.0F, 0.0F);
-            GL11.glRotatef(-animationProgress * 20F, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(-animationProgress * 80F, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(-45, 0, 1, 0);
+            GLRenderer.modelM4f().rotateY(Math.toRadians(45));
+            GLRenderer.modelM4f().rotateY(Math.toRadians(-animationProgress3) * 20F);
+            GLRenderer.modelM4f().rotateZ(Math.toRadians(-animationProgress) * 20F);
+            GLRenderer.modelM4f().rotateX(Math.toRadians(-animationProgress) * 80F);
+            GLRenderer.modelM4f().rotateY(Math.toRadians(-45));
 
-            render(tessellator,player, itemStack, DisplayPos.FIRST_PERSON_RIGHT_HAND, true, 1, brightness, alpha, partialTick, false);
+            render(tessellator,player, itemStack, DisplayPos.FIRST_PERSON_RIGHT_HAND, true, 1, lightmapCoord, partialTick, false);
         }
-        GL11.glPopMatrix();
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.popFrame();
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
     public abstract IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack);
